searchData={"items":[{"type":"module","title":"Statistex.Robust","doc":"Documentation for `Statistex.Robust`.\n\nRobust (range-based) statistics built on Statistex","ref":"Statistex.Robust.html"},{"type":"function","title":"Statistex.Robust.adjusted_box/1","doc":"Runs R script to calculate adjusted box for array (https://en.wikipedia.org/wiki/Box_plot).\n\nDepends on medcouple calculation (see: Statistex.Robust.medcouple).\n\nInput is sorted automatically.","ref":"Statistex.Robust.html#adjusted_box/1"},{"type":"function","title":"Examples - Statistex.Robust.adjusted_box/1","doc":"iex> Statistex.Robust.adjusted_box([1,1,1,1,1,1])\n    {1.0, 1.0}\n    iex> Statistex.Robust.adjusted_box([0,1,2,3,4,5])\n    {-4.5, 9.5}","ref":"Statistex.Robust.html#adjusted_box/1-examples"},{"type":"function","title":"Statistex.Robust.adjusted_box/2","doc":"Runs R script to calculate `adjusted_box/1` for indexth matrix row (https://en.wikipedia.org/wiki/Box_plot).\n\nDepends on medcouple calculation (see: Statistex.Robust.medcouple).\n\nInput is sorted automatically.","ref":"Statistex.Robust.html#adjusted_box/2"},{"type":"function","title":"Examples - Statistex.Robust.adjusted_box/2","doc":"iex> Statistex.Robust.adjusted_box([[1],[1],[1],[1],[1],[1]], 0)\n    {1.0, 1.0}","ref":"Statistex.Robust.html#adjusted_box/2-examples"},{"type":"function","title":"Statistex.Robust.mad/2","doc":"Estimates range using Median Absolute Deviation (MAD).","ref":"Statistex.Robust.html#mad/2"},{"type":"function","title":"Examples - Statistex.Robust.mad/2","doc":"iex> Statistex.Robust.mad([1, 2, 3, 4, 5, 6, 7], 3)\n    {-2.0, 10.0}\n\n    iex> Statistex.Robust.mad([10, 15, 20, 30, 50], 2)\n    {0.0, 40.0}","ref":"Statistex.Robust.html#mad/2-examples"},{"type":"function","title":"Statistex.Robust.mad/3","doc":"Estimates range using `mad/2` for a specified column (index) of a matrix.","ref":"Statistex.Robust.html#mad/3"},{"type":"function","title":"Examples - Statistex.Robust.mad/3","doc":"iex> Statistex.Robust.mad([[1], [2], [3], [4], [5], [6], [7]], 3, 0)\n    {-2.0, 10.0}\n\n    iex> Statistex.Robust.mad([[10], [15], [20], [30], [50]], 4, 0)\n    {-20.0, 60.0}","ref":"Statistex.Robust.html#mad/3-examples"},{"type":"function","title":"Statistex.Robust.mad_skew/2","doc":"Calculates an asymmetric interval around the median using a modified version\nof the MAD for skewed data by separating positive and negative deviations from the median.","ref":"Statistex.Robust.html#mad_skew/2"},{"type":"function","title":"Examples - Statistex.Robust.mad_skew/2","doc":"iex> Statistex.Robust.mad_skew([1, 2, 3, 4, 5, 6, 7], 3)\n    {-0.5, 8.5}\n\n    iex> Statistex.Robust.mad_skew([10, 15, 20, 30, 50], 4)\n    {0.0, 60.0}","ref":"Statistex.Robust.html#mad_skew/2-examples"},{"type":"function","title":"Statistex.Robust.mad_skew/3","doc":"Estimates range using `mad_skew/2` for a specified column (index) of a matrix.","ref":"Statistex.Robust.html#mad_skew/3"},{"type":"function","title":"Examples - Statistex.Robust.mad_skew/3","doc":"iex> Statistex.Robust.mad_skew([[1], [2], [3], [4], [5], [6], [7]], 3, 0)\n    {-0.5, 8.5}\n\n    iex> Statistex.Robust.mad_skew([[10], [15], [20], [30], [50]], 2, 0)\n    {10.0, 40.0}","ref":"Statistex.Robust.html#mad_skew/3-examples"},{"type":"function","title":"Statistex.Robust.medcouple/1","doc":"Runs R script to calculate medcouple on array.\n\nNote that medcouple does NOT return a range, but a value.\nFor range estimation using medcouple refer to `adjusted_box/1`.\n\nMedcouple is a robust statistic that measures the skewness of a univariate distribution.\n\nDepends on Rscript (https://www.rdocumentation.org/packages/utils/versions/3.6.2/topics/Rscript).\nDepends on library robustbase (https://cran.r-project.org/web/packages/robustbase/index.html)\n\nRscript has to be available in shell path.","ref":"Statistex.Robust.html#medcouple/1"},{"type":"function","title":"Examples - Statistex.Robust.medcouple/1","doc":"iex> Statistex.Robust.medcouple([1,1,1,1,1,1])\n    0.0\n    iex> Statistex.Robust.medcouple([0,2,2,2,2,5,10])\n    0.4","ref":"Statistex.Robust.html#medcouple/1-examples"},{"type":"function","title":"Statistex.Robust.medcouple/2","doc":"Runs R script to calculate `medcouple/1` for indexth matrix row.","ref":"Statistex.Robust.html#medcouple/2"},{"type":"function","title":"Examples - Statistex.Robust.medcouple/2","doc":"iex> Statistex.Robust.medcouple([[1],[1],[1],[1],[1],[1]], 0)\n    0.0","ref":"Statistex.Robust.html#medcouple/2-examples"},{"type":"function","title":"Statistex.Robust.minmax/2","doc":"Calculates the minimum and maximum values for a specific column in a matrix.\nThis method serves only for comparison with robust methods","ref":"Statistex.Robust.html#minmax/2"},{"type":"function","title":"Parameters - Statistex.Robust.minmax/2","doc":"- `matrix`: A list of lists (matrix) where each inner list represents a row.\n  - `index`: The index of the column for which to find the minimum and maximum values.","ref":"Statistex.Robust.html#minmax/2-parameters"},{"type":"function","title":"Returns - Statistex.Robust.minmax/2","doc":"- A tuple `{min, max}`, representing the minimum and maximum value of the specified column.","ref":"Statistex.Robust.html#minmax/2-returns"},{"type":"function","title":"Examples - Statistex.Robust.minmax/2","doc":"iex> Statistex.Robust.minmax([[1, 2, 3], [4, 5, 6], [7, 8, 9]], 0)\n    {1, 7}\n\n    iex> Statistex.Robust.minmax([[10, 20], [5, 15], [25, 30]], 1)\n    {15, 30}","ref":"Statistex.Robust.html#minmax/2-examples"},{"type":"function","title":"Statistex.Robust.z_score/2","doc":"Estimates range using Z-score.\n\nDepends on medcouple calculation (see: Statistex.Robust.medcouple).\n\nInput is sorted automatically.","ref":"Statistex.Robust.html#z_score/2"},{"type":"function","title":"Examples - Statistex.Robust.z_score/2","doc":"iex> Statistex.Robust.z_score([39.0157, 50.9985, 45.1634, 63.6410, 48.1637, 54.4420, 56.6881, 49.0387, 51.9994, 45.2520], 3)\n    {29.837277543944065, 71.04322245605594}","ref":"Statistex.Robust.html#z_score/2-examples"},{"type":"function","title":"Statistex.Robust.z_score/3","doc":"Estimates range using `z_score/2` for index'th row of a matrix.","ref":"Statistex.Robust.html#z_score/3"},{"type":"function","title":"Examples - Statistex.Robust.z_score/3","doc":"iex> Statistex.Robust.z_score([[39.0157], [50.9985], [45.1634], [63.6410], [48.1637], [54.4420], [56.6881], [49.0387], [51.9994], [45.2520]], 3,0)\n    {29.837277543944065, 71.04322245605594}","ref":"Statistex.Robust.html#z_score/3-examples"},{"type":"module","title":"Statistex.Robust.Bootstrap","doc":"Provides a method for estimating the original data range from a sample\nusing bootstrapping with extrapolation. This approach generates resampled\ndata, calculates the min and max values for each resample, and applies a\npercentage-based extrapolation to estimate a wider range than the sample\nmight initially suggest.","ref":"Statistex.Robust.Bootstrap.html"},{"type":"module","title":"Example - Statistex.Robust.Bootstrap","doc":"iex> data = [57, 57, 57, 58, 63, 66, 66, 67, 67, 68, 69, 70, 70, 70, 70, 72,\n    ...>         73, 75, 75, 76, 76, 78, 79, 81]\n    iex> n_resamples = 1000\n    iex> extrapolation_percentage = 0.10\n    iex> Statistex.Robust.Bootstrap.extrapolate(data, n_resamples, extrapolation_percentage)\n    {51.3, 89.1}","ref":"Statistex.Robust.Bootstrap.html#module-example"},{"type":"function","title":"Statistex.Robust.Bootstrap.extrapolate/3","doc":"Performs bootstrapping with extrapolation to estimate a wider range for the\noriginal data based on the provided sample.\n\n- `data`: A list of numbers representing the sample data.\n- `n_resamples`: The number of bootstrap resamples to generate.\n- `extrapolation_percentage`: The percentage of extrapolation to apply\n  on the lower and upper bounds.\n\nReturns a tuple `{extended_min, extended_max}` representing the estimated\nrange with extrapolation applied.","ref":"Statistex.Robust.Bootstrap.html#extrapolate/3"},{"type":"function","title":"Statistex.Robust.Bootstrap.extrapolate/4","doc":"Estimates range using `extrapolate/3` for a specified column (index) of a matrix.","ref":"Statistex.Robust.Bootstrap.html#extrapolate/4"},{"type":"extras","title":"README","doc":"[![Hex Version](https://img.shields.io/hexpm/v/statistex_robust.svg)](https://hex.pm/packages/statistex_robust) [![Hex Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/statistex_robust/)\n\n# Statistex.Robust\n\nStatistex.Robust provides robust, range-based statistical methods built on top of the [Statistex](https://hexdocs.pm/statistex/readme.html) library.\n\nGithub repo: https://github.com/chazzka/statistex_robust","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"The package can be installed\nby adding `statistex_robust` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:statistex_robust, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quickstart - README","doc":"For quickstart please refer to the `test` folder for simple examples or to the `example` folder for more robust examples on larger datasets.\n\nRun with:\n```\n$ MIX_ENV=example mix run example/example_bootstrap.ex\n```","ref":"readme.html#quickstart"},{"type":"extras","title":"Methods - README","doc":"### `medcouple/1`\nCalculates the medcouple, a robust statistic that measures skewness in a univariate distribution. Requires `Rscript` to be available in the shell path.\n\n```elixir\niex> Statistex.Robust.medcouple([1, 1, 1, 1, 1, 1])\n0.0\n\niex> Statistex.Robust.medcouple([0, 2, 2, 2, 2, 5, 10])\n0.4\n```\n\n### `medcouple/2`\nCalculates the medcouple for a specific column in a matrix.\n\n```elixir\niex> Statistex.Robust.medcouple([[1], [1], [1], [1], [1], [1]], 0)\n0.0\n```\n\n### `adjusted_box/1`\nCalculates the adjusted boxplot bounds for a univariate dataset, considering the medcouple for skewness. Requires `medcouple`.\n\n```elixir\niex> Statistex.Robust.adjusted_box([1, 1, 1, 1, 1, 1])\n{1.0, 1.0}\n\niex> Statistex.Robust.adjusted_box([0, 1, 2, 3, 4, 5])\n{-4.5, 9.5}\n```\n\n### `adjusted_box/2`\nCalculates the adjusted boxplot bounds for a specified column (index) of a matrix.\n\n```elixir\niex> Statistex.Robust.adjusted_box([[1], [1], [1], [1], [1], [1]], 0)\n{1.0, 1.0}\n```\n\n### `z_score/2`\nEstimates the range using Z-score for a univariate dataset.\n\n```elixir\niex> Statistex.Robust.z_score([39.0157, 50.9985, 45.1634, 63.6410, 48.1637, 54.4420, 56.6881, 49.0387, 51.9994, 45.2520], 3)\n{29.837277543944065, 71.04322245605594}\n```\n\n### `z_score/3`\nEstimates the range using Z-score for a specified column (index) in a matrix.\n\n```elixir\niex> Statistex.Robust.z_score([[39.0157], [50.9985], [45.1634], [63.6410], [48.1637], [54.4420], [56.6881], [49.0387], [51.9994], [45.2520]], 3, 0)\n{29.837277543944065, 71.04322245605594}\n```\n\n### `mad/2`\nEstimates range using the Median Absolute Deviation (MAD) for a univariate dataset.\n\n```elixir\niex> Statistex.Robust.mad([1, 2, 3, 4, 5, 6, 7], 3)\n{-2.0, 10.0}\n\niex> Statistex.Robust.mad([10, 15, 20, 30, 50], 2)\n{0.0, 40.0}\n```\n\n### `mad/3`\nEstimates range using the MAD for a specified column (index) in a matrix.\n\n```elixir\niex> Statistex.Robust.mad([[1], [2], [3], [4], [5], [6], [7]], 3, 0)\n{-2.0, 10.0}\n\niex> Statistex.Robust.mad([[10], [15], [20], [30], [50]], 4, 0)\n{-20.0, 60.0}\n```\n\n### `mad_skew/2`\nCalculates an asymmetric interval around the median using a skew-adjusted MAD.\n\n```elixir\niex> Statistex.Robust.mad_skew([1, 2, 3, 4, 5, 6, 7], 3)\n{-0.5, 8.5}\n\niex> Statistex.Robust.mad_skew([10, 15, 20, 30, 50], 4)\n{0.0, 60.0}\n```\n\n### `mad_skew/3`\nCalculates an asymmetric interval around the median using skew-adjusted MAD for a specific column (index) in a matrix.\n\n```elixir\niex> Statistex.Robust.mad_skew([[1], [2], [3], [4], [5], [6], [7]], 3, 0)\n{-0.5, 8.5}\n\niex> Statistex.Robust.mad_skew([[10], [15], [20], [30], [50]], 2, 0)\n{10.0, 40.0}\n```\n\n### `minmax/2`\nCalculates the minimum and maximum values for a specific column in a matrix.\n\n```elixir\niex> Statistex.Robust.minmax([[1, 2, 3], [4, 5, 6], [7, 8, 9]], 0)\n{1, 7}\n\niex> Statistex.Robust.minmax([[10, 20], [5, 15], [25, 30]], 1)\n{15, 30}\n```\n\n---\n\n# Statistex.Robust.Bootstrap\n\nProvides a method for estimating the original data range from a sample using bootstrapping with extrapolation. This approach generates resampled data, calculates the min and max values for each resample, and applies a percentage-based extrapolation to estimate a wider range.\n\n### `extrapolate/3`\nPerforms bootstrapping with extrapolation to estimate a wider range for the original data based on the provided sample.\n\n```elixir\niex> data = [57, 57, 57, 58, 63, 66, 66, 67, 67, 68, 69, 70, 70, 70, 70, 72, 73, 75, 75, 76, 76, 78, 79, 81]\niex> n_resamples = 1000\niex> extrapolation_percentage = 0.10\niex> Statistex.Robust.Bootstrap.extrapolate(data, n_resamples, extrapolation_percentage)\n{51.3, 89.1}\n```\n\n### `extrapolate/4`\nEstimates range using `extrapolate/3` for a specified column (index) of a matrix.\n\n```elixir\niex> data = [[57], [58], [63], [66], [67], [68], [69], [70], [72], [73], [75], [76], [78], [79], [81]]\niex> Statistex.Robust.Bootstrap.extrapolate(data, 1000, 0.10, 0)\n{51.3, 89.1}\n```\n\nThe docs can be found at  .","ref":"readme.html#methods"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}